package org.insa.graphs.algorithm.shortestpath;

import org.insa.graphs.algorithm.AbstractInputData.Mode;
import org.insa.graphs.model.Node;

public class AStarAlgorithm extends DijkstraAlgorithm {
    private Node destination;
    
    @Override
    protected Label createLabel(Node node) {
        LabelStar retour;
        if (data.getMode() == Mode.LENGTH) {
            retour = new LabelStar(node, -1, destination);
        }
        else {
            retour = new LabelStar(node, data.getGraph().getGraphInformation().getMaximumSpeed(), destination);
        }
        return retour;
    }

    public AStarAlgorithm(ShortestPathData data) {
        super(data);
        destination = data.getDestination();
    }

}
