package org.insa.graphs.algorithm.shortestpath;

import org.insa.graphs.model.Node;
import org.insa.graphs.algorithm.AbstractInputData.Mode;

public class Label implements Comparable<Label> {
  Node node;
  boolean marked;
  boolean reached;
  float pathCost;
  Node parentNode;


  public Label(Node node) {
    this.node = node;
    this.marked = false;
    this.marked = false;
    this.pathCost = Float.MAX_VALUE;
    this.parentNode = null;
  }

  public Node getNode() { return this.node; }
  public boolean isMarked() { return this.marked; }
  public void mark() { this.marked = true; }
  public boolean isReached() { return this.reached; }
  public void markReached() { this.reached = true; }
  public float getPathCost() { return this.pathCost; }
  public void setPathCost(float newCost) { this.pathCost = newCost; }
  public Node getParentNode() { return this.parentNode; }
  public void setParentNode(Node parentNode) { this.parentNode = parentNode; }

  public float getCost() {
    // function will be modified later
    
    return pathCost;
  }

  public float getTotalCost() {
    // will be overriden for A*
    return pathCost;
  }

  public int compareTo(Label other) {
    final float difference = this.getTotalCost() - other.getTotalCost();
    return (int) Math.signum(difference);
  }
}
